from .beaker import Beaker
from structlog import get_logger

log = get_logger()


class Pour:
    def __init__(self, from_beaker: Beaker, to_beaker: Beaker, transform: callable):
        self.from_beaker = from_beaker
        self.to_beaker = to_beaker
        self.transform = transform


class Recipe:
    def __init__(self, name: str):
        self.name = name
        self.pours = []

    def __str__(self) -> str:
        return f"Recipe({self.name})"

    __repr__ = __str__

    def add_pour(self, from_beaker: Beaker, to_beaker: Beaker, transform: callable):
        pour = Pour(from_beaker, to_beaker, transform)
        self.pours.append(pour)

    def run_linearly(self):
        log.info("recipe", recipe=self)
        for pour in self.pours:
            print(pour.from_beaker, pour.to_beaker, pour.transform)
            log.info(
                "pour",
                from_beaker=pour.from_beaker,
                to_beaker=pour.to_beaker,
                to_pour=len(pour.from_beaker),
            )
            for id, item in pour.from_beaker:
                log.info("pour_item", id=id, item=item)
                transformed = pour.transform(item)
                pour.to_beaker.add_item(transformed, pour.from_beaker.table_name, id)
